/****************************************************************************

 MESSAGE PASSING INTERFACE TEST CASE SUITE

 Copyright IBM Corp. 1995

 IBM Corp. hereby grants a non-exclusive license to use, copy, modify, and
 distribute this software for any purpose and without fee provided that the
 above copyright notice and the following paragraphs appear in all copies.

 IBM Corp. makes no representation that the test cases comprising this
 suite are correct or are an accurate representation of any standard.

 In no event shall IBM be liable to any party for direct, indirect, special
 incidental, or consequential damage arising out of the use of this software
 even if IBM Corp. has been advised of the possibility of such damage.

 IBM CORP. SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED
 TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS AND IBM
 CORP. HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
 ENHANCEMENTS, OR MODIFICATIONS.

****************************************************************************

 These test cases reflect an interpretation of the MPI Standard.  They are
 are, in most cases, unit tests of specific MPI behaviors.  If a user of any
 test case from this set believes that the MPI Standard requires behavior
 different than that implied by the test case we would appreciate feedback.

 Comments may be sent to:
    Richard Treumann
    treumann@kgn.ibm.com

****************************************************************************
*/
//#include "mpi.h"

import mpi.*;
class getcount {
  static public void main(String[] args) {
    //int me,data[100],count;
    int me,count;
    byte   dataBYTE[]   = new byte[5];
    char   dataCHAR[]   = new char[5];
    int    dataINT[]    = new int[5];
    float  dataFLOAT[]  = new float[5];
    double dataDOUBLE[] = new double[5];
    short  dataSHORT[]  = new short[5];
    long   dataLONG[]   = new long[5];
    //MPI_Status status;
    Status status;
    
    //MPI_Init(&argc,&argv);
    MPI.Init(args);    
    //MPI_Comm_rank(MPI_COMM_WORLD,&me);
    me=MPI.COMM_WORLD.Rank();
    
    if(me == 0)  {
      //MPI_Send(data,5,MPI_BYTE,1,1,MPI_COMM_WORLD);
      MPI.COMM_WORLD.Send(dataBYTE,0,5,MPI.BYTE,1,1);

      //MPI_Send(data,5,MPI_CHAR,1,1,MPI_COMM_WORLD);
      MPI.COMM_WORLD.Send(dataCHAR,0,5,MPI.CHAR,1,1);

      //MPI_Send(data,5,MPI_INT,1,1,MPI_COMM_WORLD);
      MPI.COMM_WORLD.Send(dataINT,0,5,MPI.INT,1,1);

      //MPI_Send(data,5,MPI_FLOAT,1,1,MPI_COMM_WORLD);
      MPI.COMM_WORLD.Send(dataFLOAT,0,5,MPI.FLOAT,1,1);

      //MPI_Send(data,5,MPI_DOUBLE,1,1,MPI_COMM_WORLD);
      MPI.COMM_WORLD.Send(dataDOUBLE,0,5,MPI.DOUBLE,1,1);

      /* MPI_Send(data,5,MPI_LONG_DOUBLE,1,1,MPI_COMM_WORLD); */

      //MPI_Send(data,5,MPI_SHORT,1,1,MPI_COMM_WORLD);
      MPI.COMM_WORLD.Send(dataSHORT,0,5,MPI.SHORT,1,1);

      //MPI_Send(data,5,MPI_LONG,1,1,MPI_COMM_WORLD);
      MPI.COMM_WORLD.Send(dataLONG,0,5,MPI.LONG,1,1);

      /*
	//MPI_Send(data,5,MPI_PACKED,1,1,MPI_COMM_WORLD);
	MPI.COMM_WORLD.Send(data,0,5,MPI.PACKED,1,1);
	//MPI_Send(data,5,MPI_UNSIGNED_CHAR,1,1,MPI_COMM_WORLD);
	MPI.COMM_WORLD.Send(data,0,5,MPI.UNSIGNED_CHAR,1,1);
	//MPI_Send(data,5,MPI_UNSIGNED_SHORT,1,1,MPI_COMM_WORLD);
	MPI.COMM_WORLD.Send(data,0,5,MPI.UNSIGNED_SHORT,1,1);
	//MPI_Send(data,5,MPI_UNSIGNED,1,1,MPI_COMM_WORLD);
	MPI.COMM_WORLD.Send(data,0,5,MPI.UNSIGNED,1,1);
	//MPI_Send(data,5,MPI_UNSIGNED_LONG,1,1,MPI_COMM_WORLD);
	MPI.COMM_WORLD.Send(data,0,5,MPI.UNSIGNED_LONG,1,1);
	*/
    } else if(me == 1)  {
      //MPI_Recv(data,5,MPI_BYTE,0,1,MPI_COMM_WORLD,&status);
      status = MPI.COMM_WORLD.Recv(dataBYTE,0,5,MPI.BYTE,0,1);
      //MPI_Get_count(&status,MPI_BYTE,&count);
      count = status.Get_count(MPI.BYTE);
      if(count != 5) 
	System.out.println
	  ("ERROR(1) in MPI_Get_count, count = "+count+", should be 5");

      //MPI_Recv(data,5,MPI_CHAR,0,1,MPI_COMM_WORLD,&status);      
      status = MPI.COMM_WORLD.Recv(dataCHAR,0,5,MPI.CHAR,0,1);
      //MPI_Get_count(&status,MPI_CHAR,&count);
      count = status.Get_count(MPI.CHAR);
      if(count != 5) 
	System.out.println
	  ("ERROR(2) in MPI_Get_count, count = "+count+", should be 5");

      //MPI_Recv(data,5,MPI_INT,0,1,MPI_COMM_WORLD,&status);
      status = MPI.COMM_WORLD.Recv(dataINT,0,5,MPI.INT,0,1);
      //MPI_Get_count(&status,MPI_INT,&count);
      count = status.Get_count(MPI.INT);
      if(count != 5) 
	System.out.println
	  ("ERROR(3) in MPI_Get_count, count = "+count+", should be 5");

      //MPI_Recv(data,5,MPI_FLOAT,0,1,MPI_COMM_WORLD,&status);
      status = MPI.COMM_WORLD.Recv(dataFLOAT,0,5,MPI.FLOAT,0,1);
      //MPI_Get_count(&status,MPI_FLOAT,&count);
      count = status.Get_count(MPI.FLOAT);
      if(count != 5) 
	System.out.println
	  ("ERROR(4) in MPI_Get_count, count = "+count+", should be 5");

      //MPI_Recv(data,5,MPI_DOUBLE,0,1,MPI_COMM_WORLD,&status);
      status = MPI.COMM_WORLD.Recv(dataDOUBLE,0,5,MPI.DOUBLE,0,1);
      //MPI_Get_count(&status,MPI_DOUBLE,&count);
      count = status.Get_count(MPI.DOUBLE);
      if(count != 5) 
	System.out.println
	  ("ERROR(5) in MPI_Get_count, count = "+count+", should be 5");

      /* #ifdef FOO
	 //MPI_Recv(data,5,MPI_LONG_DOUBLE,0,1,MPI_COMM_WORLD,&status);
	 //MPI_Get_count(&status,MPI_LONG_DOUBLE,&count);
	 if(count != 5) 
	 System.out.println
	 ("ERROR(6) in MPI_Get_count, count = "+count+", should be 5");
	 #endif
	 */

      //MPI_Recv(data,5,MPI_SHORT,0,1,MPI_COMM_WORLD,&status);
      MPI.COMM_WORLD.Recv(dataSHORT,0,5,MPI.SHORT,0,1);
      //MPI_Get_count(&status,MPI_SHORT,&count);
      count = status.Get_count(MPI.SHORT);
      if(count != 5) 
	System.out.println
	  ("ERROR(7) in MPI_Get_count, count = "+count+", should be 5");

      //MPI_Recv(data,5,MPI_LONG,0,1,MPI_COMM_WORLD,&status);
      status = MPI.COMM_WORLD.Recv(dataLONG,0,5,MPI.LONG,0,1);
      //MPI_Get_count(&status,MPI_LONG,&count);
      count = status.Get_count(MPI.LONG);
      if(count != 5) 
	System.out.println
	  ("ERROR(8) in MPI_Get_count, count = "+count+", should be 5");

      /*
	//MPI_Recv(data,5,MPI_PACKED,0,1,MPI_COMM_WORLD,&status);
	status = MPI.COMM_WORLD.Recv(data,0,5,MPI.PACKED,0,1);
	//MPI_Get_count(&status,MPI_PACKED,&count);
	count = status.Get_count(MPI.PACKED);
	if(count != 5) 
	System.out.println
	("ERROR(10) in MPI_Get_count, count = "+count+", should be 5");
	//MPI_Recv(data,5,MPI_UNSIGNED_CHAR,0,1,MPI_COMM_WORLD,&status);
	status = MPI.COMM_WORLD.Recv(data,0,5,MPI.UNSIGNED_CHAR,0,1);
	//MPI_Get_count(&status,MPI_UNSIGNED_CHAR,&count);
	count = status.Get_count(MPI.UNSIGNED_CHAR);
	if(count != 5) 
	System.out.println
	("ERROR(11) in MPI_Get_count, count = "+count+", should be 5");
	//MPI_Recv(data,5,MPI_UNSIGNED_SHORT,0,1,MPI_COMM_WORLD,&status);
	status = MPI.COMM_WORLD.Recv(data,0,5,MPI.UNSIGNED_SHORT,0,1);
	//MPI_Get_count(&status,MPI_UNSIGNED_SHORT,&count);
	count = status.Get_count(MPI.UNSIGNED_SHORT);
	if(count != 5) 
	System.out.println
	("ERROR(12) in MPI_Get_count, count = "+count+", should be 5");
	//MPI_Recv(data,5,MPI_UNSIGNED,0,1,MPI_COMM_WORLD,&status);
	status = MPI.COMM_WORLD.Recv(data,0,5,MPI.UNSIGNED,0,1);
	//MPI_Get_count(&status,MPI_UNSIGNED,&count);
	count = status.Get_count(MPI.UNSIGNED);
	if(count != 5) 
	System.out.println
	("ERROR(13) in MPI_Get_count, count = "+count+", should be 5");
	//MPI_Recv(data,5,MPI_UNSIGNED_LONG,0,1,MPI_COMM_WORLD,&status);
	status = MPI.COMM_WORLD.Recv(data,0,5,MPI.UNSIGNED_LONG,0,1);
	//MPI_Get_count(&status,MPI_UNSIGNED_LONG,&count);
	count = status.Get_count(MPI.UNSIGNED_LONG);
	if(count != 5) 
	System.out.println
	("ERROR(14) in MPI_Get_count, count = "+count+", should be 5");
	*/
    }
    //MPI_Barrier(MPI_COMM_WORLD);
    MPI.COMM_WORLD.Barrier();
    if(me == 0)  System.out.println("Get_count TEST COMPLETE.");
    MPI.Finalize();
  }  
}
